/*
 *	app.h
 *
 *	MMC/SD Card Reader
 *
 *	* Tue Nov 02 19:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>
#include "mmc_api.h"
#include "mmc_api2.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	Mass storage Bulk only / SFF-8070 dl
 ****************************************************************************/

/* SFF-8070K̃R}hꗗ
 * gK{ǖΉłv(?)h̔fASL-C860̃\[XQlɂ܂B
 *  (linux/drivers/usb/device/storage_fd/storageproto.c)
 */
//#define SFF8070_FORMAT_UNIT			0x04 /* K{ǖΉłv(?) */
#define SFF8070_INQUIRY				0x12
//#define SFF8070_MODE_SELECT			0x55 /* K{ǖΉłv(?) */
#define SFF8070_MODE_SENSE			0x5a
#define SFF8070_PREVENT_ALLOW_MEDIUM_REMOVAL	0x1e
#define SFF8070_READ_10				0x28
//#define SFF8070_READ_12			0xa8 /* Optional */
#define SFF8070_READ_CAPACITY			0x25
#define SFF8070_READ_FORMAT_CAPACITIES		0x23
#define SFF8070_REQUEST_SENSE			0x03
//#define SFF8070_SEEK				0x2b /* K{ǖΉłv(?) */
#define SFF8070_START_STOP_UNIT			0x1b
#define SFF8070_TEST_UNIT_READY			0x00
#define SFF8070_VERIFY				0x2f /*  */
#define SFF8070_WRITE_10			0x2a
//#define SFF8070_WRITE_12			0xaa /* Optional */
//#define SFF8070_WRITE_AND_VERITY		0x2e /* K{ǖΉłv(?) */

/* Command Block Wrapper */
typedef struct _CBW {
	unsigned int dCBWSignature;		/* + 0, 4 */
	unsigned int dCBWTag;			/* + 4, 4 */
	unsigned int dCBWDataTransferLength;	/* + 8, 4 */
	unsigned char bmCBWFlags;		/* +12, 1 */
	unsigned char bCBWLUN		:4;	/* +13, 1 */
	unsigned char			:4;
	unsigned char bCBWCBLength	:5;	/* +14, 1 */
	unsigned char			:3;
	unsigned char CBWCB[16];		/* +15,16 */
} __attribute__((packed)) CBW;			/* =31 */
/* CBW.dCBWSignature */
#define CBW_SIGNATURE	0x43425355/*'USBC'*/

/* Command Status Wrapper  */
typedef struct _CSW {
	unsigned int dCSWSignature;	/* + 0,4 */
	unsigned int dCSWTag;		/* + 4,4 */
	unsigned int dCSWDataResidue;	/* + 8,4 */
	unsigned char bCSWStatus;	/* +12,1 */
} __attribute__((packed)) CSW;		/* =13 */
/* CSW.dCSWSignature */
#define CSW_SIGNATURE	0x53425355/*'USBS'*/

/* INQUIRYf[^ */
typedef struct _INQUIRY_DATA {
	unsigned char PeripheralDeviceType	: 5,	/* + 0, 1 */
	              Reserved0_5		: 3;
	unsigned char Reserved1_0		: 7,	/* + 1, 1 */
	              RMB			: 1;
	unsigned char ANSIVersion		: 3,	/* + 2, 1 */
	              ECMAVersion		: 3,
	              ISOVersion		: 2;
	unsigned char ResponseDataFormat	: 4,	/* + 3, 1 */
	              Reserved3_4		: 4;
	unsigned char AdditionalLength;			/* + 4, 1 */
	unsigned char Reserved5[3];			/* + 5, 3 */
	unsigned char VendorInformation[8];		/* + 8, 8 */
	unsigned char ProductInformation[16];		/* +16,16 */
	unsigned char ProductRevisionLevel[4];		/* +32, 4 */
} __attribute__((packed)) INQUIRY_DATA;			/* =36 */
// KvɉāAunsigned char VendorSpecific[20]܂B
// KvɉāAunsigned char Reserved56[40]܂B
// KvɉāAunsigned char VendorSpecificParameters[N]܂B

/* READ FORMAT CAPACITIESf[^ */
typedef struct _READ_FORMAT_CAPACITIES_DATA {
	/* Capacity List Header */
	unsigned char Reserved0[3];			/* + 0,3 */
	unsigned char CapacityListLength;		/* + 3,1 */
	/* Current/Maximum Capacity Descriptor */
	unsigned int NumberOfBlocks;			/* + 4,4 */
	unsigned int DescriptorCode	: 2,		/* + 8,1 */
	             Reserved8_2	: 6;
	unsigned int BlockLength	:24;		/* + 9,3 (v3oCgSwap!!) */
} __attribute__((packed)) READ_FORMAT_CAPACITIES_DATA;	/* =12 */
// KvɉāAFormattable Capacity Descriptor(s)܂B

/* READ CAPACITYf[^ */
typedef struct _READ_CAPACITY_DATA {
	unsigned int LastLogicalBlockAddress;		/* +0,4 */
	unsigned int BlockLengthInBytes;		/* +4,4 */
} __attribute__((packed)) READ_CAPACITY_DATA;		/* =8 */

/* MODE SENSEf[^ */
typedef struct _MODE_PARAMETER_HEADER {
	unsigned short ModeDataLength;					/* +0,2 */
	unsigned char  MediumTypeCode;					/* +2,1 */
	unsigned char  Reserved3_0		:7,			/* +3,1 */
	               WP			:1;
	unsigned char  Reserved4[4];					/* +4,4 */
} __attribute__((packed)) MODE_PARAMETER_HEADER;			/* =8 */
// KvɉāAPage(s)܂B
typedef struct _READ_WRITE_ERROR_RECOVERY_PAGE {
	unsigned char PageCode			:6,			/* + 0,1 (=0x01) */
	              Reserved0_6		:1,
	              PS			:1;
	unsigned char PageLength;					/* + 1,1 (=0x0a) */
	unsigned char DCR			:1,			/* + 2,1 */
	              Reserved2_1		:1,
	              PER			:1,
	              Reserved2_3		:1,
	              RC			:1,
	              TB			:1,
	              Reserved2_6		:1,
	              AWRE			:1;
	unsigned char ReadRetryCount;					/* + 3,1 */
	unsigned char Reserved[4];					/* + 4,4 */
	unsigned char WriteRetryCount;					/* + 8,1 */
	unsigned char Reserved9[3];					/* + 9,3*/
} __attribute__((packed)) READ_WRITE_ERROR_RECOVERY_PAGE;		/* =12 */
typedef struct _CACHING_PAGE {
	unsigned char PageCode			:6,			/* + 0,1 (=0x08) */
	              Reserved0_6		:1,
	              PS			:1;
	unsigned char PageLength;					/* + 1,1 (=0x0a) */
	unsigned char RCD			:1,			/* + 2,1 */
	              Reserved2_1		:1,
	              WCE			:1,
	              Reserved2_3		:5;
	unsigned char Reserved3[9];					/* + 3,9 */
} __attribute__((packed)) CACHING_PAGE;					/* =12 */
typedef struct _REMOVABLE_BLOCK_ACCESS_CAPABILITIES_PAGE {
	unsigned char PageCode			:6,			/* + 0,1 (=0x1b) */
	              Reserved0_6		:1,
	              PS			:1;
	unsigned char PageLength;					/* + 1,1 (=0x0a) */
	unsigned char Reserved2_0		:6,			/* + 2,1 */
	              SRFP			:1,
	              Reserved2_7		:1;
	unsigned char TLUN			:3,			/* + 3,1 */
	              Reserved3_3		:3,
	              SML			:1,
	              NCD			:1;
	unsigned char Reserved4[8];					/* + 4,8 */
} __attribute__((packed)) REMOVABLE_BLOCK_ACCESS_CAPABILITIES_PAGE;	/* =12 */
typedef struct _TIMER_AND_PROTECT_PAGE {
	unsigned char PageCode			:6,			/* + 0,1 (=0x1c) */
	              Reserved0_6		:1,
	              PS			:1;
	unsigned char PageLength;					/* + 1,1 (=0x06) */
	unsigned char Reserved2;					/* + 2,1 */
	unsigned char InactivityTimeMultiplier	:4,			/* + 3,1 */
	              Reserved3_4		:4;
	unsigned char SWPP			:1,			/* + 4,1 */
	              DISP			:1,
	              Reserved4_2		:6;
	unsigned char Reserved5[3];					/* + 5,3 */
} __attribute__((packed)) TIMER_AND_PROTECT_PAGE;			/* = 8 */

/* REQUEST SENSEf[^ */
typedef struct _REQUEST_SENSE_DATA {
	unsigned char ErrorCode				:7,	/* + 0,1 (=0x70) */
	              Valid				:1;
	unsigned char Reserved1;				/* + 1,1 */
	unsigned char SenseKey				:4,	/* + 2,1 */
	              Reserved2_4			:1,
	              VendorSpecific2_5			:3;
	unsigned char Information[4];				/* + 3,4 ItZbgn܂̂ŁAintɂȂ悤!! */
	unsigned char AdditionalSenseLength;			/* + 7,1 (=0x0a + sizeof AdditionalSenseBytes) */
	unsigned char VendorSpecific8[4];			/* + 8,4 */
	unsigned char AdditionalSenseCode;			/* +12,1 */
	unsigned char AdditionalSenseCodeQualifier;		/* +13,1 */
	unsigned char FieldReplaceableUnitCode;			/* +14,1 */
	unsigned char SenseKeySpecific15_0		:7,	/* +15,1 */
	              SKSV				:1;
	unsigned char SenseKeySpecific16[2];			/* +16,2 */
} REQUEST_SENSE_DATA;						/* =18 */
// KvɉāAAdditional Sense Bytes܂B

/****************************************************************************
 *	
 ****************************************************************************/

#define XBUFSIZ		4096	/* Mobt@TCY() */
				/* efBXNv^≞f[^SɊi[łTCYƂ邱ƁB */
				/* ܂A2ZN^(512x2)̃f[^SɊi[łTCYƂ邱ƁB */

/* phase */
#define PHASE_IDLE	0	/* CBWM҂      */
#define PHASE_RX	1	/* ǉf[^M */
#define PHASE_TX	2	/* ǉf[^M */
#define PHASE_CSW	3	/* CSWM҂      */

void* xcat(const void* dat, int len);
#define XCAT(d) xcat(&(d), sizeof(d))

typedef struct _COMMAND_TABLE {
	int operation_code;
	void (*start)();
	void (*rxing)();
	void (*rxdone)();
	void (*txing)();
	void (*txdone)();
} COMMAND_TABLE;
int start_dispatch();
int rxing_dispatch();
int rxdone_dispatch();
int txing_dispatch();
int txdone_dispatch();

void app_init();
void app_main();
void app_exit();
void schedule();
void delay(int frame);

void ep2_rxdone(int st);
void ep2_txdone(int st);
void clear_feature(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void set_address(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void get_descriptor(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void set_configuration(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void set_interface(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
void class_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
