/*
 *	main.c
 *
 *	MMC/SD Card Reader Writer
 *
 *	* Tue Nov 02 19:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 *	* Tue Nov 03 05:13:00 JST 2004 Naoyuki Sawa
 *	- MMCΉJ[l Ver 1.25ɑΉB
 *	  mmcReadSector()֐̃\[XOAAPIĂяo悤ɕύX܂B
 *	* Thu Nov 04 00:00:00 JST 2004 Naoyuki Sawa
 *	- ݂ɂΉ܂B
 */
#include "app.h"
#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	fobOp
 ****************************************************************************/

#define DMSG_ROWS (DISP_Y / 6)
#define DMSG_COLS 256 /* dmsg()ɓn̓WJ𒴂Ȃ悤ӂĂ!! */
int dmsg_rows;
int dmsg_cnt;
char dmsg_str[DMSG_ROWS][DMSG_COLS];

void
dmsg(const char* fmt, ...)
{
	int len;
	va_list ap;

ENTER_CS;

	if(dmsg_rows == DMSG_ROWS) {
		memmove(&dmsg_str[0][0], &dmsg_str[1][0], DMSG_COLS * (DMSG_ROWS - 1));
		dmsg_rows--;
	}

	len = sprintf(&dmsg_str[dmsg_rows][0], "%d: ", dmsg_cnt);

	va_start(ap, fmt);
	vsprintf(&dmsg_str[dmsg_rows][len], fmt, ap);
	va_end(ap);

	dmsg_rows++;
	dmsg_cnt++;

LEAVE_CS;
}

void
dmsg_disp()
{
	int i;

ENTER_CS;

	memset(vbuff, 0, sizeof vbuff);

	if(dmsg_rows) {
		for(i = 0; i < dmsg_rows; i++) {
			render_string(&render, 0, i * 6, &dmsg_str[i][0], 0x82, 3);
		}
	} else {
		render_string(&render, 0, 0, "no dmsg", 0x82, 3);
	}

LEAVE_CS;
}

/****************************************************************************
 *	
 ****************************************************************************/

/* USBtbN */
const USBINF usb_inf = {
	/* USBC mode */
	mode:			D12_ENDP_NONISO,	/* EP0IN/OUT=Rg[]AEP1IN/OUT=gpAEP2IN/OUT=oN](Mass storage Bulk only) */
	/* USBC raw event */
	ep2_rxdone:		ep2_rxdone,		/* Mass storage Bulk only */
	ep2_txdone:		ep2_txdone,		/* Mass storage Bulk only */
	/* Device request */
	clear_feature:		clear_feature,
	set_address:		set_address,
	get_descriptor:		get_descriptor,
	set_configuration:	set_configuration,
	set_interface:		set_interface,
	class_request:		class_request,
};

/****************************************************************************
 *	USB descriptors
 ****************************************************************************/

/* foCXfBXNv^ */
const DEVICE_DESCRIPTOR device_desc = {
	bLength:		sizeof(DEVICE_DESCRIPTOR),
	bDescriptorType:	DEVICE_DESCRIPTOR_TYPE,
	bcdUSB:			0x0110,
	bMaxPacketSize0:	EP0_PACKET_SIZE,
	idVendor:		0x0e19,	/* PCE_VENDOR_ID */
	idProduct:		0x1014,	/* PCE_PRODUCT_ID+0x14 */
	bcdDevice:		0x0001,
	bNumConfigurations:	1,
};

/* RtBM[VfBXNv^ */
const CONFIGURATION_DESCRIPTOR config_desc = {
	bLength:		sizeof(CONFIGURATION_DESCRIPTOR),
	bDescriptorType:	CONFIGURATION_DESCRIPTOR_TYPE,
	wTotalLength:		sizeof(CONFIGURATION_DESCRIPTOR) +	/* config_desc */
				sizeof(INTERFACE_DESCRIPTOR    ) +	/* interface_desc */
				sizeof(ENDPOINT_DESCRIPTOR     ) +	/* endpoint_desc_ep2in */
				sizeof(ENDPOINT_DESCRIPTOR     ),	/* endpoint_desc_ep2out */
	bNumInterfaces:		1,
	bConfigurationValue:	1,
	bmAttributes:		0x80,		/* Bus-powered */
	MaxPower:		100 / 2,	/* 100[mA] */
};

/* C^[tFCXfBXNv^ */
const INTERFACE_DESCRIPTOR interface_desc = {
	bLength:		sizeof(INTERFACE_DESCRIPTOR),
	bDescriptorType:	INTERFACE_DESCRIPTOR_TYPE,
	bNumEndpoints:		2,
	bInterfaceClass:	8,	/* Mass storage */
	bInterfaceSubClass:	5,	/* SFF-8070i */
	bInterfaceProtocol:	0x50,	/* Bulk only */
};

/* Gh|CgfBXNv^
 * P/ECERpC̕s΍̂߁Aendpoint_desc\̔zɂȂ悤!!
 * ڂ́Aclip/clipusb.h̃RgQƂĂB
 */
const ENDPOINT_DESCRIPTOR endpoint_desc_ep2in = {
	bLength:		sizeof(ENDPOINT_DESCRIPTOR),
	bDescriptorType:	ENDPOINT_DESCRIPTOR_TYPE,
	bEndpointAddress:	0x82,	/* EP2IN */
	bAttributes:		2,	/* Bulk */
	wMaxPacketSize:		EP2_NONISO_PACKET_SIZE,
};
const ENDPOINT_DESCRIPTOR endpoint_desc_ep2out = {
	bLength:		sizeof(ENDPOINT_DESCRIPTOR),
	bDescriptorType:	ENDPOINT_DESCRIPTOR_TYPE,
	bEndpointAddress:	0x02,	/* EP2OUT */
	bAttributes:		2,	/* Bulk */
	wMaxPacketSize:		EP2_NONISO_PACKET_SIZE,
};

/****************************************************************************
 *	SFF-8070 (ATAPI Removable Rewritable Media Devices)
 ****************************************************************************/

/* INQUIRYf[^
 * SFF-8070dl(INF-8070.PDF) Page 26
 */
const INQUIRY_DATA inquiry_data = {
	PeripheralDeviceType	: 0,	/* Direct-access device */
	RMB			: 1,	/* Removable medium */
	ANSIVersion		: 0,	/* ATAPIł0Œ */
	ECMAVersion		: 0,	/* ATAPIł0Œ */
	ISOVersion		: 0,	/* ATAPIł0Œ */
	ResponseDataFormat	: 1,	/* ATAPIł1Œ */
	AdditionalLength	: 3 +	/* Reserved5 */
				  8 +	/* VendorInformation */
				  16 +	/* ProductInformation */
				  4,	/* ProductRevisionLevel */
	VendorInformation	: { 'P','i','e','c','e' },
	ProductInformation	: { 'M','m','c','R','d','W','t' },
	ProductRevisionLevel	: { '0','.','0','1' },
};

/* READ FORMAT CAPACITIESf[^
 * SFF-8070dl(INF-8070.PDF) Page 44
 */
const READ_FORMAT_CAPACITIES_DATA read_format_capacities_data = {
	/* Capacity List Header */
	CapacityListLength	: 8,			/* Current/Maximum Capacity Descriptor */
	/* Current/Maximum Capacity Descriptor */
	NumberOfBlocks		: SWAPW(-1),		/* ̃hCuőΉ\ȍőubN?BMaximum͏ɂł݂ */
	DescriptorCode		: 3,			/* No Cartridge in Drive - Maximum formattable capacity for any cartridge */
	BlockLength		: 0,			/* ]ɐݒBv3oCgSwapBSWAPW(sctsiz)>>8łBSWAPW(sctsiz)_!! */
};

/* READ CAPACITYf[^
 * SFF-8070dl(INF-8070.PDF) Page 43
 */
const READ_CAPACITY_DATA read_capacity_data = {
	LastLogicalBlockAddress	: 0,			/* ]ɐݒBSWAPW(sctnum-1)łBSWAPW(sctnum)Ȃ!! */
	BlockLengthInBytes	: 0,			/* ]ɐݒBSWAPW(sctsiz)łB */
};

/* MODE SENSEf[^
 * SFF-8070dl(INF-8070.PDF) Page 30`
 */
const MODE_PARAMETER_HEADER mode_parameter_header = {
	ModeDataLength		: 0,			/* ]ɐݒ */
							/*   sizeof mode_parameter_header */
							/* - sizeof mode_parameter_header.ModeDataLength */
							/* + sizeof Page(s) */
//	WP			: 1,			/* Write protected */
};
const READ_WRITE_ERROR_RECOVERY_PAGE read_write_error_recovery_page = {
	PageCode		: 0x01,
	PageLength		: 0x0a,
};
const CACHING_PAGE caching_page = {
	PageCode		: 0x08,
	PageLength		: 0x0a,
};
const REMOVABLE_BLOCK_ACCESS_CAPABILITIES_PAGE removable_block_access_capabilities_page = {
	PageCode		: 0x1b,
	PageLength		: 0x0a,
	TLUN			: 1,
};
const TIMER_AND_PROTECT_PAGE timer_and_protect_page = {
	PageCode		: 0x1c,
	PageLength		: 0x06,
};

/* REQUEST SENSEf[^
 * SFF-8070dl(INF-8070.PDF) Page 48`
 */
REQUEST_SENSE_DATA request_sense_data = {
	ErrorCode			: 0x70,
	SenseKey			: 5,	/* ݒ */
	AdditionalSenseLength		: 0x0a,
	AdditionalSenseCode		: 0,	/* ݒ */
	AdditionalSenseCodeQualifier	: 0,	/* ݒ */
};

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static void
err_exit(const char* fmt, ...)
{
	int x;
	int y;
	int len;
	va_list ap;
	char str[100]; /* ꂮ炢Ώ[H */

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	memset(vbuff, 0, sizeof vbuff);
	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	render_string(&render, x, y, str, 0x80, 3);

	for(;;) {
		schedule();
		if(joy & (TRG_AB | TRG_SELECT)) break;
	}

	exit(1);
}

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* MMCB */
	if(pceSystemGetInfo()->bios_ver < VERSION(1, 25)) {
		err_exit("MMC1.25ȏオK{ł");
	}
	if(mmcInit(MMC_FILESIZE_MAX) != 1) {
		err_exit("MMC̏Ɏs܂");
	}
	if(mmcInitCore2() != 1) { /* mmcWriteSector()̏ */
		err_exit("MMC̏Ɏs܂");
	}
	if(mmcGetCIDInfo(&cid) != 1) {
		err_exit("CID̎擾Ɏs܂");
	}
	if(mmcGetCSDInfo(&csd) != 1) {
		err_exit("CSD̎擾Ɏs܂");
	}
	if(csd.usReadBlockLength != csd.usWriteBlockLength ||
	   csd.usReadBlockLength > XBUFSIZ / 2) {
		err_exit("Ή̃ZN^TCYł");
	}
	sctsiz = csd.usReadBlockLength;
	sctnum = csd.ulTatalBlocks;

	/* PCrunŎsꍇ̉̂߂ɁAxUSBtbN܂B */
	delay(SEC(0.1));
	usb_init(&usb_inf);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mUSBtbN܂B */
	usb_free();

	/* MMCIB */
	mmcExit();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	pceLCDTrans();		/* ʍXV */
	yield();		/* VXe */
	joy = pcePadGet();	/* pbhԍXV */
	now++;			/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	for(;;) {
		schedule();
		if(joy & TRG_SELECT) break;

		if(joy & PAD_B) {
			/* fobO\B */
			dmsg_disp();
		} else {
			/* ʏ̉ʕ\B */
			memset(vbuff, 0, sizeof vbuff);
			pceFontSetType(0x80);
			pceFontSetTxColor(0);
			pceFontSetBkColor(3);
			pceFontSetPos((DISP_X - 10 * 13) / 2, 0);
			/*             OPQRSTUVWXOPQ */
			pceFontPutStr("==== MMC/SD Card RdWr ====");
			pceFontSetTxColor(3);
			pceFontSetBkColor(0);
			pceFontSetPos(4, 24);
			pceFontPrintf("ǎoCgF%8u\n", log_rdcnt % 100000000);
			pceFontSetPos(4, 39);
			pceFontPrintf("݃oCgF%8u\n", log_wrcnt % 100000000);
			pceFontSetPos(4, 54);
			pceFontPrintf("Ήv񐔁F%8u\n", log_errcnt % 100000000);
			pceFontSetTxColor(0);
			pceFontSetBkColor(2);
			pceFontSetPos((DISP_X - 10 * 13) / 2, DISP_Y - 10);
			/*             OPQRSTUVWXOPQ */
			pceFontPutStr(" SELECT{^ŏI܂ ");
		}
	}
}

/****************************************************************************
 *	xcat
 ****************************************************************************/

void*
xcat(const void* dat, int len)
{
	void* p;

	if(xlen + len > XBUFSIZ) {
		len -= (xlen + len) - XBUFSIZ;
	}
	p = memcpy(&xbuf[xlen], dat, len);
	xlen += len;

	return p; /* ܃Rs[f[^́ARs[擪AhXԂ܂ */
}

/****************************************************************************
 *	Device request
 ****************************************************************************/

void
clear_feature(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	int endp;

	switch(req->bmRequestType & 0x1f) { /* recipient */

	case 0x00: /* device */
		switch(req->wValue) {
		case 1: /* device remote wakeup */
			goto L_ERR; /* Ή */
		case 2: /* test mode */
			goto L_ERR; /* Ή */
		}
		goto L_ERR;

	case 0x01: /* interface */
		/* no features */
		goto L_ERR;

	case 0x02: /* endpoint */
		switch(req->wValue) {
		case 0: /* endpoint halt */
			endp = req->wIndex & 0x7f;
			if(endp > 2) goto L_ERR; /* EPx */
			endp *= 2; /* EP0=0or1/EP1=2or3/EP2=4or5 */
			if(req->wIndex & 0x80) endp += 1; /* EPx IN */
			D12_SetEndpointStatus(endp, 0); /* STALL */
			usb_ep0_tx(NULL, 0); /* ACK */

			/* Mass storage Bulk onlydl
			 * BULK-IÑXg[ƂɁAM҂CSWAɑM܂B
			 */
			if(endp == 5 && phase == PHASE_CSW) ep2_txdone(0);

			return;
		}
		goto L_ERR;
	}

L_ERR:
	usb_ep0_stall();
}

void
set_address(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	/* foCXAhXݒ肵܂B */
	D12_SetAddressEnable(req->wValue, 1);
	usb_ep0_tx(NULL, 0); /* ACK */
}

void
get_descriptor(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	switch(req->wValue & 0xff00) {

	case 0x0100: /* Device */
		xlen = 0;
		XCAT(device_desc);
		usb_ep0_tx(xbuf, xlen);
		return;

	case 0x0200: /* Configuration */
		xlen = 0;
		XCAT(config_desc);
		XCAT(interface_desc);
		XCAT(endpoint_desc_ep2in);
		XCAT(endpoint_desc_ep2out);
		usb_ep0_tx(xbuf, xlen);
		return;

	case 0x0300: /* String */
	case 0x0400: /* Interface */
	case 0x0500: /* Endpoint */
	case 0x0600: /* Device qualifier */
	case 0x0700: /* Other speed configuration */
	case 0x0800: /* Interface power */
		goto L_ERR; /* Ή */
	}

L_ERR:
	usb_ep0_stall();
}

void
set_configuration(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	/* RtBO[V#1(ꂵ܂)IꂽA
	 * CGh|CgLɂ܂B
	 */
	D12_SetEndpointEnable(req->wValue == 1);
	usb_ep0_tx(NULL, 0); /* ACK */
}

void
set_interface(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	/* C^[tFCX͂ЂƂȂ̂ŁA܂B */
	usb_ep0_tx(NULL, 0); /* ACK */
}
void
class_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	switch(req->bRequest) {
	case 0xff: /* Bulk-Only Mass Storage Reset */
		/* tF[YBXg[Ԃ͈ێ܂B */
		phase = PHASE_IDLE;
		usb_ep0_tx(NULL, 0);
		return;

	case 0xfe: /* Get Max LUN */
		/* PLUN̏ꍇSTALLOKB(Bulk-Onlydl) */
		goto L_ERR;
	}

L_ERR:
	usb_ep0_stall();
}

/****************************************************************************
 *	Mass storage Bulk only
 ****************************************************************************/

void
ep2_rxdone(int st)
{
	int len;
	unsigned char buf[EP2_NONISO_PACKET_SIZE];

	/* CGh|Cg̓_uobt@Ȃ̂ŁAܓ͂ĂpPbgSďȂ΂܂B
	 * pPbgc܂܏ԂƁAcpPbgɑ΂銄荞݂͍Ĕ܂B
	 */
	for(;;) {
		switch(phase) {

		/* CBWM҂ */
		case PHASE_IDLE:

			/* CBW擾܂B */
			len = D12_ReadEndpoint(4, &cbw, sizeof(CBW));
			if(len == -1) { /* Mf[^ */
				goto L_EXIT;
			}
			if((len != sizeof(CBW)) || (cbw.dCBWSignature != CBW_SIGNATURE)) {
				/* sCBW͖܂B
				 * * Mass storage Bulk only̎dlł́AtF[YG[STALLׂƎv̂łA
				 *   ۂɂĂ݂ƁAȂOSsɂȂACPUgp100%ɂȂĂ܂܂...
				 */
				goto L_NEXT; /* ̎Mf[^o */
			}

			/* CSẄꕔĂ܂B
			 * eR}hstart,rxdone,txdoneR[obNɂāAbCSWStatusK؂ɐݒ肵ĂB
			 * bCSWStatus0ȊOɕύXƂ́Arequest_sense_dataݒ肷邱ƂYȂ!!
			 * bCSWStatus!=0request_sense_data.SenseKey==0̉́AOSsɂ܂!!
			 */
			memset(&csw, 0, sizeof csw);
			csw.dCSWSignature = CSW_SIGNATURE;
			csw.dCSWTag = cbw.dCBWTag;
			csw.dCSWDataResidue = cbw.dCBWDataTransferLength;

			/* MJE^NAĂ܂B
			 * eR}hstartR[obNɂāAxlenK؂ɐݒ肵ĂB
			 */
			xcnt = 0;	/* ʎZMTCY */
			xlen = 0;	/* Mobt@݈ʒu */

			/* R}hJnB */
			if(!start_dispatch()) {
/*{{DEBUG*/
				dmsg("start_dispatch %02x fail", cbw.CBWCB[0]);
/*}}DEBUG*/
				csw.bCSWStatus = 1; /* COMMAND FAILED */
				/* 05,20,00: INVALID COMMAND OPERATION CODE */
				request_sense_data.SenseKey = 0x05;
				request_sense_data.AdditionalSenseCode = 0x20;
				request_sense_data.AdditionalSenseCodeQualifier = 0x00;
			}

			/* M܂CSWMJnB */
			if(cbw.bmCBWFlags & 0x80) { /* DATA-IN (device to host) */
				if(cbw.dCBWDataTransferLength) { /* Mf[^ */
					phase = PHASE_TX;
					ep2_txdone(0);
				} else { /* Mf[^Ȃ */
					phase = PHASE_CSW;
					ep2_txdone(0);
				}
			} else { /* DATA-OUT (host to device) */
				if(cbw.dCBWDataTransferLength) { /* Mf[^ */
					phase = PHASE_RX;
				} else { /* Mf[^Ȃ */
					phase = PHASE_CSW;
					ep2_txdone(0);
				}
			}

			break;

		/* f[^M */
		case PHASE_RX:

			/* MpPbg擾܂B
			 * * zXgfoCX̃f[^ʐḾAfoCX邩ۂɂ炸MKv܂B
			 *   (dlɂ́ASTALLŒfłƏĂ܂AۂɂOSsɂȂ݂ł...)
			 *   Mobt@ꂸt̏Ԃ̂܂܂łĂApPbgKǂݏo߂ɁA
			 *   ڑMobt@֓ǂݍނ̂ł͂ȂAꎞIȃobt@oR邱Ƃɂ܂B
			 */
			len = D12_ReadEndpoint(4, buf, EP2_NONISO_PACKET_SIZE);
			if(len == -1) { /* Mf[^ */
				goto L_EXIT;
			}
			csw.dCSWDataResidue -= len;
			xcnt += len;

			/* MpPbgi[󂫂Ȃ΁Aʒmċ󂫂܂B */
			if(xlen + len > XBUFSIZ) {
				rxing_dispatch();
			}

			/* Mobt@Ɋi[܂B
			 * Mobt@ɋ󂫂Ȃ΁AKvɉČ㔼Jbg܂B
			 */
			xcat(buf, len);

			/* MAR}hɒʒmāACSWԑ܂B
			 * * zXgfoCX̃f[^ʐḾAKdCBWDataTransferLength҂Ŋ͂łA
			 *   Ô߁AdCBWDataTransferLength𒴂MAyC[hTCYȉ̃pPbgMɂ
			 *   Me邱Ƃɂ܂B(󋵂邩ǂ͖mFł)
			 */
			if((xcnt >= cbw.dCBWDataTransferLength) || (len < EP2_NONISO_PACKET_SIZE)) {
				rxdone_dispatch();

				/* Mobt@͋󂢂Ă͂Ȃ̂ŁACSW𑗐M܂B */
				phase = PHASE_CSW;
				ep2_txdone(0);
			}

			break;

		default:

			/* M҂ȊÕtF[YŎMf[^邱Ƃ͂肦܂񂪁A
			 * Ô߁AǂݏoĔj邱Ƃɂ܂B
			 */
			len = D12_ReadEndpoint(4, buf, EP2_NONISO_PACKET_SIZE);
			if(len == -1) { /* Mf[^ */
				goto L_EXIT;
			}

			/*{{LOG*/
			if(csw.bCSWStatus) log_errcnt++;
			/*}}LOG*/

			break;
		}
L_NEXT:
	}
L_EXIT:
}

void
ep2_txdone(int st)
{
	int len;

	switch(phase) {

	/* f[^M */
	case PHASE_TX:

		/* 1pPbg̑Mf[^Ȃ΁Aʒm܂B */
		if(xlen < EP2_NONISO_PACKET_SIZE) {
			txing_dispatch();
		}

		/* pPbg𑗐M܂B */
		len = xlen;
		if(xcnt + len > cbw.dCBWDataTransferLength) {
			len = cbw.dCBWDataTransferLength - xcnt;
		}
		if(len > EP2_NONISO_PACKET_SIZE) {
			len = EP2_NONISO_PACKET_SIZE;
		}
		D12_WriteEndpoint(5, xbuf, len);
		csw.dCSWDataResidue -= len;
		xcnt += len;

		/* MAobt@̑Oɋ󂫂ł̂ŁAl߂܂B */
		memmove(&xbuf[0], &xbuf[len], xlen - len);
		xlen -= len;

		/* MAR}hɒʒm܂B
		 * * foCXzXg̒ʐḾA҂dCBWDataTransferLength܂őMȊOɂA
		 *   yC[hTCỸpPbgMŊł܂B(Mass storage Bulk onlydl)
		 */
		if((xcnt >= cbw.dCBWDataTransferLength) || (len < EP2_NONISO_PACKET_SIZE)) {
			txdone_dispatch();

			/* ܑf[^̑MɁACSW𑗐M悤\񂵂܂B */
			phase = PHASE_CSW;
		}

		break;

	/* CSWM҂ */
	case PHASE_CSW:
		/*{{LOG*/
		if(csw.bCSWStatus) log_errcnt++;
		/*}}LOG*/

		/* CSW𑗐M܂B */
		D12_WriteEndpoint(5, &csw, sizeof(CSW));
		phase = PHASE_IDLE;

		break;
	}
}

/****************************************************************************
 *	SFF-8070 (ATAPI Removable Rewritable Media Devices)
 ****************************************************************************/

void
start_inquiry()
{
	XCAT(inquiry_data);
}

void
start_mode_sense()
{
	MODE_PARAMETER_HEADER* hdr;

	hdr = XCAT(mode_parameter_header);

	switch(cbw.CBWCB[2]/*PC|PageCode*/) {
	case 0x01:
		XCAT(read_write_error_recovery_page);
		break;
	case 0x08:
		XCAT(caching_page);
		break;
	case 0x1b:
		XCAT(removable_block_access_capabilities_page);
		break;
	case 0x1c:
		XCAT(timer_and_protect_page);
		break;
	case 0x3f:
		XCAT(read_write_error_recovery_page);
		XCAT(caching_page);
		XCAT(removable_block_access_capabilities_page);
		XCAT(timer_and_protect_page);
		break;
	default:
/*{{DEBUG*/
		dmsg("MODE SENSE %02x fail", cbw.CBWCB[2]);
/*}}DEBUG*/
		xlen = 0; /* XCAT(mode_parameter_header)LZ */
		/*  dv!! 
		 * * Windows2000ŎƁAȂXPageCode00v܂B
		 *   (ȃy[WR[hAdlɍڂĂȂ...?)
		 * - ̗vɑ΂Ă"bCSWStatus = 1"CSWԂA
		 *   ɑREQUEST SENSEɑ΂"SenseKey!=0"ԂĂB
		 *   ȂƁAWindows 2000CPUgp100%ɂȂA
		 *   "foCX̒~"ACRȂȂ܂B
		 */
		csw.bCSWStatus = 1; /* COMMAND FAILED */
		/* 05,24,00: INVALID FIELD IN COMMAND PACKET */
		request_sense_data.SenseKey = 0x05;
		request_sense_data.AdditionalSenseCode = 0x24;
		request_sense_data.AdditionalSenseCodeQualifier = 0x00;
		break;
	}

	if(xlen) {
		hdr->ModeDataLength = xlen - 2/*ModeDataLength̕͏*/;
	}
}

void
start_prevent_allow_medium_removal()
{
	/** no job **/
}

void
start_read_10()
{
	sctpos = cbw.CBWCB[2] << 24 |	/* Logical Block Address */
		 cbw.CBWCB[3] << 16 |
		 cbw.CBWCB[4] <<  8 |
		 cbw.CBWCB[5] <<  0;
	sctcnt = cbw.CBWCB[7] <<  8 |	/* Transfer Length */
		 cbw.CBWCB[8] <<  0;
}

void
txing_read_10()
{
	/* 1ZN^ȏǂݍ߂󂫂... */
	while(xlen + sctsiz <= XBUFSIZ) {

		/* ǂݍރZN^Ȃ΁A܂B */
		if(!sctcnt) return;

		/* 1ZN^ǂݍ݂܂B */
		if(mmcReadSector(sctpos, &xbuf[xlen]) != 1) {
/*{{DEBUG*/
			dmsg("mmcReadSector fail");
/*}}DEBUG*/
			sctcnt = 0; /* cǂݍ݂LZ */
			csw.bCSWStatus = 1; /* COMMAND FAILED */
			/* 03,11,00: UNRECOVERED READ ERROR */
			request_sense_data.SenseKey = 0x03;
			request_sense_data.AdditionalSenseCode = 0x11;
			request_sense_data.AdditionalSenseCodeQualifier = 0x00;
			return;
		}
		xlen += sctsiz;

		/*{{LOG*/
		log_rdcnt += sctsiz;
		/*}}LOG*/

		/* ̓ǂݍ݃ZN^ʒui߁Ac萔炵܂B */
		sctpos++;
		sctcnt--;
	}
}

void
start_read_capacity()
{
	READ_CAPACITY_DATA* p;
	p = XCAT(read_capacity_data);
	p->LastLogicalBlockAddress = SWAPW(sctnum - 1);
	p->BlockLengthInBytes = SWAPW(sctsiz);
}

void
start_read_format_capacities()
{
	READ_FORMAT_CAPACITIES_DATA* p;
	p = XCAT(read_format_capacities_data);
	p->BlockLength = SWAPW(sctsiz) >> 8; /* 3oCgSwap!! */
}

void
start_request_sense()
{
	XCAT(request_sense_data);
}

void
start_start_stop_unit()
{
	/** no job **/
}

void
start_test_unit_ready()
{
	/** no job **/
}

void
start_write_10()
{
	sctpos = cbw.CBWCB[2] << 24 |	/* Logical Block Address */
		 cbw.CBWCB[3] << 16 |
		 cbw.CBWCB[4] <<  8 |
		 cbw.CBWCB[5] <<  0;
	sctcnt = cbw.CBWCB[7] <<  8 |	/* Transfer Length */
		 cbw.CBWCB[8] <<  0;
}

void
start_verify()
{
	/** no job **/

	/* 㑱̔rpf[^͖āAɐƂ܂B */
}

void
rxing_write_10()
{
	/* 1ZN^ȏ̎Mf[^... */
	while(xlen >= sctsiz) {

		/* ރZN^Ȃ΁A܂B */
		if(!sctcnt) return;

		/* 1ZN^݂܂B */
		if(mmcWriteSector(sctpos, &xbuf[0]) != 1) {
/*{{DEBUG*/
			dmsg("mmcWriteSector fail");
/*}}DEBUG*/
			sctcnt = 0; /* c菑݂LZ */
			csw.bCSWStatus = 1; /* COMMAND FAILED */
			/* 07,27,00: WRITE PROTECTED MEDIA b */
			request_sense_data.SenseKey = 0x07;
			request_sense_data.AdditionalSenseCode = 0x27;
			request_sense_data.AdditionalSenseCodeQualifier = 0x00;
			return;
		}

		/* 񂾕Aobt@̑Oɋ󂫂ł̂ŁAl߂܂B */
		memmove(&xbuf[0], &xbuf[sctsiz], xlen - sctsiz);
		xlen -= sctsiz;

		/*{{LOG*/
		log_wrcnt += sctsiz;
		/*}}LOG*/

		/* ̏݃ZN^ʒui߁Ac萔炵܂B */
		sctpos++;
		sctcnt--;
	}
}

void
rxdone_write_10()
{
	rxing_write_10();
}

const COMMAND_TABLE command_table[] = {
	{ SFF8070_INQUIRY, start:start_inquiry },
	{ SFF8070_MODE_SENSE, start:start_mode_sense },
	{ SFF8070_PREVENT_ALLOW_MEDIUM_REMOVAL, start:start_prevent_allow_medium_removal },
	{ SFF8070_READ_10, start:start_read_10, txing:txing_read_10 },
	{ SFF8070_READ_CAPACITY, start:start_read_capacity },
	{ SFF8070_READ_FORMAT_CAPACITIES, start:start_read_format_capacities },
	{ SFF8070_REQUEST_SENSE, start:start_request_sense },
	{ SFF8070_START_STOP_UNIT, start:start_start_stop_unit },
	{ SFF8070_TEST_UNIT_READY, start:start_test_unit_ready },
	{ SFF8070_VERIFY, start:start_verify }, /* Windows 2000ł́AtH[}bgɗ܂ */
	{ SFF8070_WRITE_10, start:start_write_10, rxing:rxing_write_10, rxdone:rxdone_write_10 },
};

#define DISPATCH(name) \
	int name##_dispatch() { \
		void (*fn)() = NULL; \
		int i; \
		for(i = 0; i < COUNTOF(command_table); i++) { \
			if(command_table[i].operation_code == cbw.CBWCB[0]) { \
				fn = command_table[i].name; \
				break; \
			} \
		} \
		if(fn) fn(); \
		return fn != NULL; \
	}
	DISPATCH(start)
	DISPATCH(rxing)
	DISPATCH(rxdone)
	DISPATCH(txing)
	DISPATCH(txdone)
#undef DISPATCH

